// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function TestAnimationInitialize(screen, w, h, dx, dy, state){
  var width, height, density;

  width = {};
  height = {};
  density = {};

  state.x = 0;
  state.y = 0;
  state.dx = Math.floor(dx);
  state.dy = Math.floor(dy);
  state.w = w;
  state.h = h;

  GetScreenSpecifications(screen, width, height, density);

  state.width = width.numberValue;
  state.height = height.numberValue;
  state.density = density.numberValue;

  state.image = CreateImage(state.width, state.height, GetBlack());
  state.screenbuffer = [];
  state.screenbuffer.length = state.width*state.height*3;

  return true;
}
function TestAnimationFreeState(state){
  DeleteImage(state.image);
  delete(state.screenbuffer);
  delete(state);
}
function TestAnimationIteration(screen, state){
  var x, y, p, i;
  var c;

  DrawFilledRectangle(state.image, 0, 0, state.width, state.height, GetBlack());

  DrawFilledRectangle(state.image, state.x, state.y, state.w, state.h, GetWhite());

  for(i = 0; i < Math.abs(state.dx); i = i + 1){
    state.x = state.x + state.dx/Math.abs(state.dx);

    if(state.x + state.w >= state.width || state.x <= 0){
      state.dx =  -state.dx;
    }
  }

  for(i = 0; i < Math.abs(state.dy); i = i + 1){
    state.y = state.y + state.dy/Math.abs(state.dy);

    if(state.y + state.h >= state.height || state.y <= 0){
      state.dy =  -state.dy;
    }
  }

  p = 0;
  for(y = 0; y < state.height; y = y + 1){
    for(x = 0; x < state.width; x = x + 1){
      c = state.image.x[x].y[y];
      state.screenbuffer[p + 0] = c.r;
      state.screenbuffer[p + 1] = c.g;
      state.screenbuffer[p + 2] = c.b;
      p = p + 3;
    }
  }

  Display(screen, state.screenbuffer);
  Sync(screen);
}
function test(){
  var failures;

  failures = CreateNumberReference(0);

  TestPing1(failures);

  return failures.numberValue;
}
function TestPing1(failures){
  var state;
  var screen;
  var i;

  screen = {};
  screen.height = 100;
  screen.width = 200;

  state = {};

  TestAnimationInitialize(screen, 10, 10, 1, 1, state);

  for(i = 0; i < 200; i = i + 1){
    TestAnimationIteration(screen, state);
  }

  AssertEquals(state.x, 180, failures);
  AssertEquals(state.y, 20, failures);
}
function GetScreenSpecifications(screen, width, height, density){
  width.numberValue = screen.width;
  height.numberValue = screen.height;
  density.numberValue = screen.density;
}
function Display(screen, pixels){
  screen.currentScreen = pixels;
}
function Sync(screen){
  var done;

  done = false;

  if(screen.waitsLeft <= 0){
    done = true;
    screen.waitsLeft = screen.waits;
  }else{
    screen.waitsLeft = screen.waitsLeft - 1;
  }

  return done;
}
function GetKeboardSpecifications(screen, characters, controlKeys, simultaneous){
  characters.numberValue = screen.characters;
  controlKeys.numberValue = screen.controlKeys;
  simultaneous.numberValue = screen.simultaneous;
}
function GetKeyboardState(screen, keysDown){
  if(screen.keyboardstatesCount < screen.keyboardstates.length){
    keysDown.numberArray = screen.keyboardstates[screen.keyboardstatesCount].numberArray;
    screen.keyboardstatesCount = screen.keyboardstatesCount + 1;
  }else{
    keysDown.numberArray = [];
    keysDown.numberArray.length = 0;
  }
}
function GetMouseSpecifications(screen, buttons, simultaneous){
  buttons.numberValue = screen.mouseButtons;
  simultaneous.numberValue = screen.simultaneousMouseButtons;
}
function GetMouseState(screen, x, y, buttonStates){
  if(screen.mouseStatesCount < screen.mouseStates.length){
    buttonStates.numberArray = screen.keyboardstates[screen.keyboardstatesCount].numberArray;
    x.numberValue = screen.x[screen.keyboardstatesCount];
    y.numberValue = screen.y[screen.keyboardstatesCount];
    screen.keyboardstatesCount = screen.keyboardstatesCount + 1;
  }else{
    buttonStates.numberArray = [];
    buttonStates.numberArray.length = 0;
  }
}
function CreateBooleanReference(value){
  var ref;

  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;

  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;

  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;

  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;

  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;

  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;

  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;

  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function GetBlack(){
  var black;
  black = {};
  black.a = 1;
  black.r = 0;
  black.g = 0;
  black.b = 0;
  return black;
}
function GetWhite(){
  var white;
  white = {};
  white.a = 1;
  white.r = 1;
  white.g = 1;
  white.b = 1;
  return white;
}
function GetTransparent(){
  var transparent;
  transparent = {};
  transparent.a = 0;
  transparent.r = 0;
  transparent.g = 0;
  transparent.b = 0;
  return transparent;
}
function GetGray(percentage){
  var black;
  black = {};
  black.a = 1;
  black.r = 1 - percentage;
  black.g = 1 - percentage;
  black.b = 1 - percentage;
  return black;
}
function CreateRGBColor(r, g, b){
  var color;
  color = {};
  color.a = 1;
  color.r = r;
  color.g = g;
  color.b = b;
  return color;
}
function CreateRGBAColor(r, g, b, a){
  var color;
  color = {};
  color.a = a;
  color.r = r;
  color.g = g;
  color.b = b;
  return color;
}
function CreateImage(w, h, color){
  var image;
  var i, j;

  image = {};
  image.x = [];
  image.x.length = w;
  for(i = 0; i < w; i = i + 1){
    image.x[i] = {};
    image.x[i].y = [];
    image.x[i].y.length = h;
    for(j = 0; j < h; j = j + 1){
      image.x[i].y[j] = {};
      SetPixel(image, i, j, color);
    }
  }

  return image;
}
function DeleteImage(image){
  var i, j, w, h;

  w = ImageWidth(image);
  h = ImageHeight(image);

  for(i = 0; i < w; i = i + 1){
    for(j = 0; j < h; j = j + 1){
      delete(image.x[i].y[j]);
    }
    delete(image.x[i]);
  }
  delete(image);
}
function ImageWidth(image){
  return image.x.length;
}
function ImageHeight(image){
  var height;

  if(ImageWidth(image) == 0){
    height = 0;
  }else{
    height = image.x[0].y.length;
  }

  return height;
}
function SetPixel(image, x, y, color){
  if(x >= 0 && x < ImageWidth(image) && y >= 0 && y < ImageHeight(image)){
    image.x[x].y[y].a = color.a;
    image.x[x].y[y].r = color.r;
    image.x[x].y[y].g = color.g;
    image.x[x].y[y].b = color.b;
  }
}
function DrawPixel(image, x, y, color){
  var ra, ga, ba, aa;
  var rb, gb, bb, ab;
  var ro, go, bo, ao;

  if(x >= 0 && x < ImageWidth(image) && y >= 0 && y < ImageHeight(image)){
    ra = color.r;
    ga = color.g;
    ba = color.b;
    aa = color.a;

    rb = image.x[x].y[y].r;
    gb = image.x[x].y[y].g;
    bb = image.x[x].y[y].b;
    ab = image.x[x].y[y].a;

    ao = CombineAlpha(aa, ab);

    ro = AlphaBlend(ra, aa, rb, ab, ao);
    go = AlphaBlend(ga, aa, gb, ab, ao);
    bo = AlphaBlend(ba, aa, bb, ab, ao);

    image.x[x].y[y].r = ro;
    image.x[x].y[y].g = go;
    image.x[x].y[y].b = bo;
    image.x[x].y[y].a = ao;
  }
}
function CombineAlpha(as, ad){
  return as + ad*(1 - as);
}
function AlphaBlend(cs, as, cd, ad, ao){
  return (cs*as + cd*ad*(1 - as))/ao;
}
function DrawHorizontalLine1px(image, x, y, lengthx, color){
  var i;

  for(i = 0; i < lengthx; i = i + 1){
    DrawPixel(image, x + i, y, color);
  }
}
function DrawVerticalLine1px(image, x, y, height, color){
  var i;

  for(i = 0; i < height; i = i + 1){
    DrawPixel(image, x, y + i, color);
  }
}
function DrawRectangle1px(image, x, y, width, height, color){
  DrawHorizontalLine1px(image, x, y, width + 1, color);
  DrawVerticalLine1px(image, x, y + 1, height + 1 - 1, color);
  DrawVerticalLine1px(image, x + width, y + 1, height + 1 - 1, color);
  DrawHorizontalLine1px(image, x + 1, y + height, width + 1 - 2, color);
}
function DrawImageOnImage(dst, src, topx, topy){
  var y, x;

  for(y = 0; y < ImageHeight(src); y = y + 1){
    for(x = 0; x < ImageWidth(src); x = x + 1){
      if(topx + x >= 0 && topx + x < ImageWidth(dst) && topy + y >= 0 && topy + y < ImageHeight(dst)){
        DrawPixel(dst, topx + x, topy + y, src.x[x].y[y]);
      }
    }
  }
}
function DrawLine1px(image, x0, y0, x1, y1, color){
  XiaolinWusLineAlgorithm(image, x0, y0, x1, y1, color);
}
function XiaolinWusLineAlgorithm(image, x0, y0, x1, y1, color){
  var steep;
  var x, t, dx, dy, g, xEnd, yEnd, xGap, xpxl1, ypxl1, intery, xpxl2, ypxl2, olda;

  olda = color.a;

  steep = Math.abs(y1 - y0) > Math.abs(x1 - x0);

  if(steep){
    t = x0;
    x0 = y0;
    y0 = t;

    t = x1;
    x1 = y1;
    y1 = t;
  }
  if(x0 > x1){
    t = x0;
    x0 = x1;
    x1 = t;

    t = y0;
    y0 = y1;
    y1 = t;
  }

  dx = x1 - x0;
  dy = y1 - y0;
  g = dy/dx;

  if(dx == 0){
    g = 1;
  }

  xEnd = Round(x0);
  yEnd = y0 + g*(xEnd - x0);
  xGap = OneMinusFractionalPart(x0 + 0.5);
  xpxl1 = xEnd;
  ypxl1 = Math.floor(yEnd);
  if(steep){
    DrawPixel(image, ypxl1, xpxl1, SetBrightness(color, OneMinusFractionalPart(yEnd)*xGap));
    DrawPixel(image, ypxl1 + 1, xpxl1, SetBrightness(color, FractionalPart(yEnd)*xGap));
  }else{
    DrawPixel(image, xpxl1, ypxl1, SetBrightness(color, OneMinusFractionalPart(yEnd)*xGap));
    DrawPixel(image, xpxl1, ypxl1 + 1, SetBrightness(color, FractionalPart(yEnd)*xGap));
  }
  intery = yEnd + g;

  xEnd = Round(x1);
  yEnd = y1 + g*(xEnd - x1);
  xGap = FractionalPart(x1 + 0.5);
  xpxl2 = xEnd;
  ypxl2 = Math.floor(yEnd);
  if(steep){
    DrawPixel(image, ypxl2, xpxl2, SetBrightness(color, OneMinusFractionalPart(yEnd)*xGap));
    DrawPixel(image, ypxl2 + 1, xpxl2, SetBrightness(color, FractionalPart(yEnd)*xGap));
  }else{
    DrawPixel(image, xpxl2, ypxl2, SetBrightness(color, OneMinusFractionalPart(yEnd)*xGap));
    DrawPixel(image, xpxl2, ypxl2 + 1, SetBrightness(color, FractionalPart(yEnd)*xGap));
  }

  if(steep){
    for(x = xpxl1 + 1; x <= xpxl2 - 1; x = x + 1){
      DrawPixel(image, Math.floor(intery), x, SetBrightness(color, OneMinusFractionalPart(intery)));
      DrawPixel(image, Math.floor(intery) + 1, x, SetBrightness(color, FractionalPart(intery)));
      intery = intery + g;
    }
  }else{
    for(x = xpxl1 + 1; x <= xpxl2 - 1; x = x + 1){
      DrawPixel(image, x, Math.floor(intery), SetBrightness(color, OneMinusFractionalPart(intery)));
      DrawPixel(image, x, Math.floor(intery) + 1, SetBrightness(color, FractionalPart(intery)));
      intery = intery + g;
    }
  }

  color.a = olda;
}
function OneMinusFractionalPart(x){
  return 1 - FractionalPart(x);
}
function FractionalPart(x){
  return x - Math.floor(x);
}
function SetBrightness(color, newBrightness){
  color.a = newBrightness;
  return color;
}
function DrawQuadraticBezierCurve(image, x0, y0, cx, cy, x1, y1, color){
  var t, dt, dx, dy;
  var xs, ys, xe, ye;

  dx = Math.abs(x0 - x1);
  dy = Math.abs(y0 - y1);

  dt = 1/Math.sqrt(Math.pow(dx, 2) + Math.pow(dy, 2));

  xs = {};
  ys = {};
  xe = {};
  ye = {};

  QuadraticBezierPoint(x0, y0, cx, cy, x1, y1, 0, xs, ys);
  for(t = dt; t <= 1; t = t + dt){
    QuadraticBezierPoint(x0, y0, cx, cy, x1, y1, t, xe, ye);
    DrawLine1px(image, xs.numberValue, ys.numberValue, xe.numberValue, ye.numberValue, color);
    xs.numberValue = xe.numberValue;
    ys.numberValue = ye.numberValue;
  }

  delete(xs);
  delete(ys);
  delete(xe);
  delete(ye);
}
function QuadraticBezierPoint(x0, y0, cx, cy, x1, y1, t, x, y){
  x.numberValue = Math.pow(1 - t, 2)*x0 + (1 - t)*2*t*cx + Math.pow(t, 2)*x1;
  y.numberValue = Math.pow(1 - t, 2)*y0 + (1 - t)*2*t*cy + Math.pow(t, 2)*y1;
}
function DrawCubicBezierCurve(image, x0, y0, c0x, c0y, c1x, c1y, x1, y1, color){
  var t, dt, dx, dy;
  var xs, ys, xe, ye;

  dx = Math.abs(x0 - x1);
  dy = Math.abs(y0 - y1);

  dt = 1/Math.sqrt(Math.pow(dx, 2) + Math.pow(dy, 2));

  xs = {};
  ys = {};
  xe = {};
  ye = {};

  CubicBezierPoint(x0, y0, c0x, c0y, c1x, c1y, x1, y1, 0, xs, ys);
  for(t = dt; t <= 1; t = t + dt){
    CubicBezierPoint(x0, y0, c0x, c0y, c1x, c1y, x1, y1, t, xe, ye);
    DrawLine1px(image, xs.numberValue, ys.numberValue, xe.numberValue, ye.numberValue, color);
    xs.numberValue = xe.numberValue;
    ys.numberValue = ye.numberValue;
  }

  delete(xs);
  delete(ys);
  delete(xe);
  delete(ye);
}
function CubicBezierPoint(x0, y0, c0x, c0y, c1x, c1y, x1, y1, t, x, y){
  x.numberValue = Math.pow(1 - t, 3)*x0 + Math.pow(1 - t, 2)*3*t*c0x + (1 - t)*3*Math.pow(t, 2)*c1x + Math.pow(t, 3)*x1;

  y.numberValue = Math.pow(1 - t, 3)*y0 + Math.pow(1 - t, 2)*3*t*c0y + (1 - t)*3*Math.pow(t, 2)*c1y + Math.pow(t, 3)*y1;
}
function CopyImage(image){
  var copy;
  var i, j;

  copy = CreateImage(ImageWidth(image), ImageHeight(image), GetTransparent());

  for(i = 0; i < ImageWidth(image); i = i + 1){
    for(j = 0; j < ImageHeight(image); j = j + 1){
      SetPixel(copy, i, j, image.x[i].y[j]);
    }
  }

  return copy;
}
function GetImagePixel(image, x, y){
  return image.x[x].y[y];
}
function HorizontalFlip(img){
  var y, x;
  var tmp;
  var c1, c2;

  for(y = 0; y < ImageHeight(img); y = y + 1){
    for(x = 0; x < ImageWidth(img)/2; x = x + 1){
      c1 = img.x[x].y[y];
      c2 = img.x[ImageWidth(img) - 1 - x].y[y];

      tmp = c1.a;
      c1.a = c2.a;
      c2.a = tmp;

      tmp = c1.r;
      c1.r = c2.r;
      c2.r = tmp;

      tmp = c1.g;
      c1.g = c2.g;
      c2.g = tmp;

      tmp = c1.b;
      c1.b = c2.b;
      c2.b = tmp;
    }
  }
}
function DrawFilledRectangle(image, x, y, w, h, color){
  var i, j;

  for(i = 0; i < w; i = i + 1){
    for(j = 0; j < h; j = j + 1){
      SetPixel(image, x + i, y + j, color);
    }
  }
}
function RotateAntiClockwise90Degrees(image){
  var rotated;
  var x, y;

  rotated = CreateImage(ImageHeight(image), ImageWidth(image), GetBlack());

  for(y = 0; y < ImageHeight(image); y = y + 1){
    for(x = 0; x < ImageWidth(image); x = x + 1){
      SetPixel(rotated, y, ImageWidth(image) - 1 - x, GetImagePixel(image, x, y));
    }
  }

  return rotated;
}
function DrawCircle(canvas, xCenter, yCenter, radius, color){
  DrawCircleBasicAlgorithm(canvas, xCenter, yCenter, radius, color);
}
function BresenhamsCircleDrawingAlgorithm(canvas, xCenter, yCenter, radius, color){
  var x, y, delta;

  y = radius;
  x = 0;

  delta = 3 - 2*radius;
  for(; y >= x; x = x + 1){
    DrawLine1px(canvas, xCenter + x, yCenter + y, xCenter + x, yCenter + y, color);
    DrawLine1px(canvas, xCenter + x, yCenter - y, xCenter + x, yCenter - y, color);
    DrawLine1px(canvas, xCenter - x, yCenter + y, xCenter - x, yCenter + y, color);
    DrawLine1px(canvas, xCenter - x, yCenter - y, xCenter - x, yCenter - y, color);

    DrawLine1px(canvas, xCenter - y, yCenter + x, xCenter - y, yCenter + x, color);
    DrawLine1px(canvas, xCenter - y, yCenter - x, xCenter - y, yCenter - x, color);
    DrawLine1px(canvas, xCenter + y, yCenter + x, xCenter + y, yCenter + x, color);
    DrawLine1px(canvas, xCenter + y, yCenter - x, xCenter + y, yCenter - x, color);

    if(delta < 0){
      delta = delta + 4*x + 6;
    }else{
      delta = delta + 4*(x - y) + 10;
      y = y - 1;
    }
  }
}
function DrawCircleMidpointAlgorithm(canvas, xCenter, yCenter, radius, color){
  var d, x, y;

  d = Math.floor((5 - radius*4)/4);
  x = 0;
  y = radius;

  for(; x <= y; x = x + 1){
    DrawPixel(canvas, xCenter + x, yCenter + y, color);
    DrawPixel(canvas, xCenter + x, yCenter - y, color);
    DrawPixel(canvas, xCenter - x, yCenter + y, color);
    DrawPixel(canvas, xCenter - x, yCenter - y, color);
    DrawPixel(canvas, xCenter + y, yCenter + x, color);
    DrawPixel(canvas, xCenter + y, yCenter - x, color);
    DrawPixel(canvas, xCenter - y, yCenter + x, color);
    DrawPixel(canvas, xCenter - y, yCenter - x, color);

    if(d < 0){
      d = d + 2*x + 1;
    }else{
      d = d + 2*(x - y) + 1;
      y = y - 1;
    }
  }
}
function DrawCircleBasicAlgorithm(canvas, xCenter, yCenter, radius, color){
  var pixels, a, da, dx, dy;

  /* Place the circle in the center of the pixel. */
  xCenter = Math.floor(xCenter) + 0.5;
  yCenter = Math.floor(yCenter) + 0.5;

  pixels = 2*Math.PI*radius;

  /* Below a radius of 10 pixels, over-compensate to get a smoother circle. */
  if(radius < 10){
    pixels = pixels*10;
  }

  da = 2*Math.PI/pixels;

  for(a = 0; a < 2*Math.PI; a = a + da){
    dx = Math.cos(a)*radius;
    dy = Math.sin(a)*radius;

    /* Floor to get the pixel coordinate. */
    DrawPixel(canvas, Math.floor(xCenter + dx), Math.floor(yCenter + dy), color);
  }
}
function DrawFilledCircle(canvas, x, y, r, color){
  DrawFilledCircleBasicAlgorithm(canvas, x, y, r, color);
}
function DrawFilledCircleMidpointAlgorithm(canvas, xCenter, yCenter, radius, color){
  var d, x, y;

  d = Math.floor((5 - radius*4)/4);
  x = 0;
  y = radius;

  for(; x <= y; x = x + 1){
    DrawLineBresenhamsAlgorithm(canvas, xCenter + x, yCenter + y, xCenter - x, yCenter + y, color);
    DrawLineBresenhamsAlgorithm(canvas, xCenter + x, yCenter - y, xCenter - x, yCenter - y, color);
    DrawLineBresenhamsAlgorithm(canvas, xCenter + y, yCenter + x, xCenter - y, yCenter + x, color);
    DrawLineBresenhamsAlgorithm(canvas, xCenter + y, yCenter - x, xCenter - y, yCenter - x, color);

    if(d < 0){
      d = d + 2*x + 1;
    }else{
      d = d + 2*(x - y) + 1;
      y = y - 1;
    }
  }
}
function DrawFilledCircleBasicAlgorithm(canvas, xCenter, yCenter, radius, color){
  var pixels, a, da, dx, dy;

  /* Place the circle in the center of the pixel. */
  xCenter = Math.floor(xCenter) + 0.5;
  yCenter = Math.floor(yCenter) + 0.5;

  pixels = 2*Math.PI*radius;

  /* Below a radius of 10 pixels, over-compensate to get a smoother circle. */
  if(radius < 10){
    pixels = pixels*10;
  }

  da = 2*Math.PI/pixels;

  /* Draw lines for a half-circle to fill an entire circle. */
  for(a = 0; a < Math.PI; a = a + da){
    dx = Math.cos(a)*radius;
    dy = Math.sin(a)*radius;

    /* Floor to get the pixel coordinate. */
    DrawVerticalLine1px(canvas, Math.floor(xCenter - dx), Math.floor(yCenter - dy), Math.floor(2*dy) + 1, color);
  }
}
function DrawTriangle(canvas, xCenter, yCenter, height, color){
  var x1, y1, x2, y2, x3, y3;

  x1 = Math.floor(xCenter + 0.5);
  y1 = Math.floor(Math.floor(yCenter + 0.5) - height);
  x2 = x1 - 2*height*Math.tan(Math.PI/6);
  y2 = Math.floor(y1 + 2*height);
  x3 = x1 + 2*height*Math.tan(Math.PI/6);
  y3 = Math.floor(y1 + 2*height);

  DrawLine1px(canvas, x1, y1, x2, y2, color);
  DrawLine1px(canvas, x1, y1, x3, y3, color);
  DrawLine1px(canvas, x2, y2, x3, y3, color);
}
function DrawFilledTriangle(canvas, xCenter, yCenter, height, color){
  var i, offset, x1, y1;

  x1 = Math.floor(xCenter + 0.5);
  y1 = Math.floor(Math.floor(yCenter + 0.5) - height);

  for(i = 0; i <= 2*height; i = i + 1){
    offset = Math.floor(i*Math.tan(Math.PI/6));
    DrawHorizontalLine1px(canvas, x1 - offset, y1 + i, 2*offset, color);
  }
}
function DrawLine(canvas, x1, y1, x2, y2, thickness, color){
  DrawLineBresenhamsAlgorithmThick(canvas, x1, y1, x2, y2, thickness, color);
}
function DrawLineBresenhamsAlgorithmThick(canvas, x1, y1, x2, y2, thickness, color){
  var x, y, dx, dy, incX, incY, pdx, pdy, es, el, err, t, r;

  dx = x2 - x1;
  dy = y2 - y1;

  incX = Sign(dx);
  incY = Sign(dy);

  dx = Math.abs(dx);
  dy = Math.abs(dy);

  if(dx > dy){
    pdx = incX;
    pdy = 0;
    es = dy;
    el = dx;
  }else{
    pdx = 0;
    pdy = incY;
    es = dx;
    el = dy;
  }

  x = x1;
  y = y1;
  err = el/2;

  if(thickness >= 3){
    r = thickness/2;
    DrawCircle(canvas, x, y, r, color);
  }else if(Math.floor(thickness) == 2){
    DrawFilledRectangle(canvas, x, y, 2, 2, color);
  }else if(Math.floor(thickness) == 1){
    DrawPixel(canvas, x, y, color);
  }

  for(t = 0; t < el; t = t + 1){
    err = err - es;
    if(err < 0){
      err = err + el;
      x = x + incX;
      y = y + incY;
    }else{
      x = x + pdx;
      y = y + pdy;
    }

    if(thickness >= 3){
      r = thickness/2;
      DrawCircle(canvas, x, y, r, color);
    }else if(Math.floor(thickness) == 2){
      DrawFilledRectangle(canvas, x, y, 2, 2, color);
    }else if(Math.floor(thickness) == 1){
      DrawPixel(canvas, x, y, color);
    }
  }
}
function DrawLineBresenhamsAlgorithm(canvas, x1, y1, x2, y2, color){
  var x, y, dx, dy, incX, incY, pdx, pdy, es, el, err, t;

  dx = x2 - x1;
  dy = y2 - y1;

  incX = Sign(dx);
  incY = Sign(dy);

  dx = Math.abs(dx);
  dy = Math.abs(dy);

  if(dx > dy){
    pdx = incX;
    pdy = 0;
    es = dy;
    el = dx;
  }else{
    pdx = 0;
    pdy = incY;
    es = dx;
    el = dy;
  }

  x = x1;
  y = y1;
  err = el/2;
  DrawPixel(canvas, x, y, color);

  for(t = 0; t < el; t = t + 1){
    err = err - es;
    if(err < 0){
      err = err + el;
      x = x + incX;
      y = y + incY;
    }else{
      x = x + pdx;
      y = y + pdy;
    }

    DrawPixel(canvas, x, y, color);
  }
}
function DrawLineBresenhamsAlgorithmThickPatterned(canvas, x1, y1, x2, y2, thickness, pattern, offset, color){
  var x, y, dx, dy, incX, incY, pdx, pdy, es, el, err, t, r;

  dx = x2 - x1;
  dy = y2 - y1;

  incX = Sign(dx);
  incY = Sign(dy);

  dx = Math.abs(dx);
  dy = Math.abs(dy);

  if(dx > dy){
    pdx = incX;
    pdy = 0;
    es = dy;
    el = dx;
  }else{
    pdx = 0;
    pdy = incY;
    es = dx;
    el = dy;
  }

  x = x1;
  y = y1;
  err = el/2;

  offset.numberValue = (offset.numberValue + 1)%(pattern.length*thickness);

  if(pattern[Math.floor(offset.numberValue/thickness)]){
    if(thickness >= 3){
      r = thickness/2;
      DrawCircle(canvas, x, y, r, color);
    }else if(Math.floor(thickness) == 2){
      DrawFilledRectangle(canvas, x, y, 2, 2, color);
    }else if(Math.floor(thickness) == 1){
      DrawPixel(canvas, x, y, color);
    }
  }

  for(t = 0; t < el; t = t + 1){
    err = err - es;
    if(err < 0){
      err = err + el;
      x = x + incX;
      y = y + incY;
    }else{
      x = x + pdx;
      y = y + pdy;
    }

    offset.numberValue = (offset.numberValue + 1)%(pattern.length*thickness);

    if(pattern[Math.floor(offset.numberValue/thickness)]){
      if(thickness >= 3){
        r = thickness/2;
        DrawCircle(canvas, x, y, r, color);
      }else if(Math.floor(thickness) == 2){
        DrawFilledRectangle(canvas, x, y, 2, 2, color);
      }else if(Math.floor(thickness) == 1){
        DrawPixel(canvas, x, y, color);
      }
    }
  }
}
function GetLinePattern5(){
  var pattern;

  pattern = [];
  pattern.length = 19;

  pattern[0] = true;
  pattern[1] = true;
  pattern[2] = true;
  pattern[3] = true;
  pattern[4] = true;
  pattern[5] = true;
  pattern[6] = true;
  pattern[7] = true;
  pattern[8] = true;
  pattern[9] = true;
  pattern[10] = false;
  pattern[11] = false;
  pattern[12] = false;
  pattern[13] = true;
  pattern[14] = true;
  pattern[15] = true;
  pattern[16] = false;
  pattern[17] = false;
  pattern[18] = false;

  return pattern;
}
function GetLinePattern4(){
  var pattern;

  pattern = [];
  pattern.length = 13;

  pattern[0] = true;
  pattern[1] = true;
  pattern[2] = true;
  pattern[3] = true;
  pattern[4] = true;
  pattern[5] = true;
  pattern[6] = true;
  pattern[7] = true;
  pattern[8] = true;
  pattern[9] = true;
  pattern[10] = false;
  pattern[11] = false;
  pattern[12] = false;

  return pattern;
}
function GetLinePattern3(){
  var pattern;

  pattern = [];
  pattern.length = 13;

  pattern[0] = true;
  pattern[1] = true;
  pattern[2] = true;
  pattern[3] = true;
  pattern[4] = true;
  pattern[5] = true;
  pattern[6] = false;
  pattern[7] = false;
  pattern[8] = false;
  pattern[9] = true;
  pattern[10] = true;
  pattern[11] = false;
  pattern[12] = false;

  return pattern;
}
function GetLinePattern2(){
  var pattern;

  pattern = [];
  pattern.length = 4;

  pattern[0] = true;
  pattern[1] = true;
  pattern[2] = false;
  pattern[3] = false;

  return pattern;
}
function GetLinePattern1(){
  var pattern;

  pattern = [];
  pattern.length = 8;

  pattern[0] = true;
  pattern[1] = true;
  pattern[2] = true;
  pattern[3] = true;
  pattern[4] = true;
  pattern[5] = false;
  pattern[6] = false;
  pattern[7] = false;

  return pattern;
}
function Blur(src, pixels){
  var dst;
  var x, y, w, h;

  w = ImageWidth(src);
  h = ImageHeight(src);
  dst = CreateImage(w, h, GetTransparent());

  for(x = 0; x < w; x = x + 1){
    for(y = 0; y < h; y = y + 1){
      SetPixel(dst, x, y, CreateBlurForPoint(src, x, y, pixels));
    }
  }

  return dst;
}
function CreateBlurForPoint(src, x, y, pixels){
  var rgba;
  var i, j, countColor, countTransparent;
  var fromx, tox, fromy, toy;
  var w, h;
  var alpha;

  w = src.x.length;
  h = src.x[0].y.length;

  rgba = {};
  rgba.r = 0;
  rgba.g = 0;
  rgba.b = 0;
  rgba.a = 0;

  fromx = x - pixels;
  fromx = Math.max(fromx, 0);

  tox = x + pixels;
  tox = Math.min(tox, w - 1);

  fromy = y - pixels;
  fromy = Math.max(fromy, 0);

  toy = y + pixels;
  toy = Math.min(toy, h - 1);

  countColor = 0;
  countTransparent = 0;
  for(i = fromx; i < tox; i = i + 1){
    for(j = fromy; j < toy; j = j + 1){
      alpha = src.x[i].y[j].a;
      if(alpha > 0){
        rgba.r = rgba.r + src.x[i].y[j].r;
        rgba.g = rgba.g + src.x[i].y[j].g;
        rgba.b = rgba.b + src.x[i].y[j].b;
        countColor = countColor + 1;
      }
      rgba.a = rgba.a + alpha;
      countTransparent = countTransparent + 1;
    }
  }

  if(countColor > 0){
    rgba.r = rgba.r/countColor;
    rgba.g = rgba.g/countColor;
    rgba.b = rgba.b/countColor;
  }else{
    rgba.r = 0;
    rgba.g = 0;
    rgba.b = 0;
  }

  if(countTransparent > 0){
    rgba.a = rgba.a/countTransparent;
  }else{
    rgba.a = 0;
  }

  return rgba;
}
function AssertFalse(b, failures){
  if(b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertTrue(b, failures){
  if( !b ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertEquals(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleansEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertCharactersEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringEquals(a, b, failures){
  if( !StringsEqual(a, b) ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertNumberArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertEquals(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleanArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertBooleansEqual(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertStringEquals(a[i].string, b[i].string, failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function Negate(x){
  return  -x;
}
function Positive(x){
  return  +x;
}
function Factorial(x){
  var i, f;

  f = 1;

  for(i = 2; i <= x; i = i + 1){
    f = f*i;
  }

  return f;
}
function Round(x){
  return Math.floor(x + 0.5);
}
function BankersRound(x){
  var r;

  if(Absolute(x - Truncate(x)) == 0.5){
    if( !DivisibleBy(Round(x), 2) ){
      r = Round(x) - 1;
    }else{
      r = Round(x);
    }
  }else{
    r = Round(x);
  }

  return r;
}
function Ceil(x){
  return Math.ceil(x);
}
function Floor(x){
  return Math.floor(x);
}
function Truncate(x){
  var t;

  if(x >= 0){
    t = Math.floor(x);
  }else{
    t = Math.ceil(x);
  }

  return t;
}
function Absolute(x){
  return Math.abs(x);
}
function Logarithm(x){
  return Math.log10(x);
}
function NaturalLogarithm(x){
  return Math.log(x);
}
function Sin(x){
  return Math.sin(x);
}
function Cos(x){
  return Math.cos(x);
}
function Tan(x){
  return Math.tan(x);
}
function Asin(x){
  return Math.asin(x);
}
function Acos(x){
  return Math.acos(x);
}
function Atan(x){
  return Math.atan(x);
}
function Atan2(y, x){
  var a;

  /* Atan2 is an invalid operation when x = 0 and y = 0, but this method does not return errors. */
  a = 0;

  if(x > 0){
    a = Atan(y/x);
  }else if(x < 0 && y >= 0){
    a = Atan(y/x) + Math.PI;
  }else if(x < 0 && y < 0){
    a = Atan(y/x) - Math.PI;
  }else if(x == 0 && y > 0){
    a = Math.PI/2;
  }else if(x == 0 && y < 0){
    a =  -Math.PI/2;
  }

  return a;
}
function Squareroot(x){
  return Math.sqrt(x);
}
function Exp(x){
  return Math.exp(x);
}
function DivisibleBy(a, b){
  return ((a%b) == 0);
}
function Combinations(n, k){
  var i, j, c;

  c = 1;
  j = 1;
  i = n - k + 1;

  for(; i <= n; ){
    c = c*i;
    c = c/j;

    i = i + 1;
    j = j + 1;
  }

  return c;
}
function Permutations(n, k){
  var i, c;

  c = 1;

  for(i = n - k + 1; i <= n; i = i + 1){
    c = c*i;
  }

  return c;
}
function EpsilonCompare(a, b, epsilon){
  return Math.abs(a - b) < epsilon;
}
function GreatestCommonDivisor(a, b){
  var t;

  for(; b != 0; ){
    t = b;
    b = a%b;
    a = t;
  }

  return a;
}
function GCDWithSubtraction(a, b){
  var g;

  if(a == 0){
    g = b;
  }else{
    for(; b != 0; ){
      if(a > b){
        a = a - b;
      }else{
        b = b - a;
      }
    }

    g = a;
  }

  return g;
}
function IsInteger(a){
  return (a - Math.floor(a)) == 0;
}
function GreatestCommonDivisorWithCheck(a, b, gcdReference){
  var success;
  var gcd;

  if(IsInteger(a) && IsInteger(b)){
    gcd = GreatestCommonDivisor(a, b);
    gcdReference.numberValue = gcd;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function LeastCommonMultiple(a, b){
  var lcm;

  if(a > 0 && b > 0){
    lcm = Math.abs(a*b)/GreatestCommonDivisor(a, b);
  }else{
    lcm = 0;
  }

  return lcm;
}
function Sign(a){
  var s;

  if(a > 0){
    s = 1;
  }else if(a < 0){
    s =  -1;
  }else{
    s = 0;
  }

  return s;
}
function Max(a, b){
  return Math.max(a, b);
}
function Min(a, b){
  return Math.min(a, b);
}
function Power(a, b){
  return Math.pow(a, b);
}
function Gamma(x){
  return LanczosApproximation(x);
}
function LogGamma(x){
  return Math.log(Gamma(x));
}
function LanczosApproximation(z){
  var p;
  var i, y, t, x;

  p = [];
  p.length = 8;
  p[0] = 676.5203681218851;
  p[1] =  -1259.1392167224028;
  p[2] = 771.32342877765313;
  p[3] =  -176.61502916214059;
  p[4] = 12.507343278686905;
  p[5] =  -0.13857109526572012;
  p[6] = 9.9843695780195716e-6;
  p[7] = 1.5056327351493116e-7;

  if(z < 0.5){
    y = Math.PI/(Math.sin(Math.PI*z)*LanczosApproximation(1 - z));
  }else{
    z = z - 1;
    x = 0.99999999999980993;
    for(i = 0; i < p.length; i = i + 1){
      x = x + p[i]/(z + i + 1);
    }
    t = z + p.length - 0.5;
    y = Math.sqrt(2*Math.PI)*Math.pow(t, z + 0.5)*Math.exp( -t)*x;
  }

  return y;
}
function Beta(x, y){
  return Gamma(x)*Gamma(y)/Gamma(x + y);
}
function Sinh(x){
  return (Math.exp(x) - Math.exp( -x))/2;
}
function Cosh(x){
  return (Math.exp(x) + Math.exp( -x))/2;
}
function Tanh(x){
  return Sinh(x)/Cosh(x);
}
function Cot(x){
  return 1/Math.tan(x);
}
function Sec(x){
  return 1/Math.cos(x);
}
function Csc(x){
  return 1/Math.sin(x);
}
function Coth(x){
  return Cosh(x)/Sinh(x);
}
function Sech(x){
  return 1/Cosh(x);
}
function Csch(x){
  return 1/Sinh(x);
}
function Error(x){
  var y, t, tau, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10;

  if(x == 0){
    y = 0;
  }else if(x < 0){
    y =  -Error( -x);
  }else{
    c1 =  -1.26551223;
    c2 =  +1.00002368;
    c3 =  +0.37409196;
    c4 =  +0.09678418;
    c5 =  -0.18628806;
    c6 =  +0.27886807;
    c7 =  -1.13520398;
    c8 =  +1.48851587;
    c9 =  -0.82215223;
    c10 =  +0.17087277;

    t = 1/(1 + 0.5*Math.abs(x));

    tau = t*Math.exp( -(Math.pow(x, 2)) + c1 + t*(c2 + t*(c3 + t*(c4 + t*(c5 + t*(c6 + t*(c7 + t*(c8 + t*(c9 + t*c10)))))))));

    y = 1 - tau;
  }

  return y;
}
function ErrorInverse(x){
  var y, a, t;

  a = (8*(Math.PI - 3))/(3*Math.PI*(4 - Math.PI));

  t = 2/(Math.PI*a) + Math.log(1 - Math.pow(x, 2))/2;
  y = Sign(x)*Math.sqrt(Math.sqrt(Math.pow(t, 2) - Math.log(1 - Math.pow(x, 2))/a) - t);

  return y;
}
function FallingFactorial(x, n){
  var k, y;

  y = 1;

  for(k = 0; k <= n - 1; k = k + 1){
    y = y*(x - k);
  }

  return y;
}
function RisingFactorial(x, n){
  var k, y;

  y = 1;

  for(k = 0; k <= n - 1; k = k + 1){
    y = y*(x + k);
  }

  return y;
}
function Hypergeometric(a, b, c, z, maxIterations, precision){
  var y;

  if(Math.abs(z) >= 0.5){
    y = Math.pow(1 - z,  -a)*HypergeometricDirect(a, c - b, c, z/(z - 1), maxIterations, precision);
  }else{
    y = HypergeometricDirect(a, b, c, z, maxIterations, precision);
  }

  return y;
}
function HypergeometricDirect(a, b, c, z, maxIterations, precision){
  var y, yp, n;
  var done;

  y = 0;
  done = false;

  for(n = 0; n < maxIterations &&  !done ; n = n + 1){
    yp = RisingFactorial(a, n)*RisingFactorial(b, n)/RisingFactorial(c, n)*Math.pow(z, n)/Factorial(n);
    if(Math.abs(yp) < precision){
      done = true;
    }
    y = y + yp;
  }

  return y;
}
function BernouilliNumber(n){
  return AkiyamaTanigawaAlgorithm(n);
}
function AkiyamaTanigawaAlgorithm(n){
  var m, j, B;
  var A;

  A = [];
  A.length = n + 1;

  for(m = 0; m <= n; m = m + 1){
    A[m] = 1/(m + 1);
    for(j = m; j >= 1; j = j - 1){
      A[j - 1] = j*(A[j - 1] - A[j]);
    }
  }

  B = A[0];

  delete(A);

  return B;
}
function StringToNumberArray(string){
  var i;
  var array;

  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function NumberArrayToString(array){
  var i;
  var string;

  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function NumberArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function BooleanArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function StringsEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function FillNumberArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillString(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillBooleanArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillNumberArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillBooleanArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillStringRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyNumberArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyBooleanArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyString(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function IsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function CreateNumberArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillNumberArray(array, value);

  return array;
}
function CreateBooleanArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillBooleanArray(array, value);

  return array;
}
function CreateString(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillString(array, value);

  return array;
}
function SwapElementsOfNumberArray(A, ai, bi){
  var tmp;

  tmp = A[ai];
  A[ai] = A[bi];
  A[bi] = tmp;
}
function SwapElementsOfStringArray(A, ai, bi){
  var tmp;

  tmp = A.stringArray[ai];
  A.stringArray[ai] = A.stringArray[bi];
  A.stringArray[bi] = tmp;
}
function ReverseNumberArray(array){
  var i;

  for(i = 0; i < array.length/2; i = i + 1){
    SwapElementsOfNumberArray(array, i, array.length - i - 1);
  }
}


module.exports = {
	TestAnimationInitialize: TestAnimationInitialize,
	TestAnimationFreeState: TestAnimationFreeState,
	TestAnimationIteration: TestAnimationIteration,
	GetScreenSpecifications: GetScreenSpecifications,
	Display: Display,
	Sync: Sync,
	GetKeboardSpecifications: GetKeboardSpecifications,
	GetKeyboardState: GetKeyboardState,
	GetMouseSpecifications: GetMouseSpecifications,
	GetMouseState: GetMouseState,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	GetBlack: GetBlack,
	GetWhite: GetWhite,
	GetTransparent: GetTransparent,
	GetGray: GetGray,
	CreateRGBColor: CreateRGBColor,
	CreateRGBAColor: CreateRGBAColor,
	CreateImage: CreateImage,
	DeleteImage: DeleteImage,
	ImageWidth: ImageWidth,
	ImageHeight: ImageHeight,
	SetPixel: SetPixel,
	DrawPixel: DrawPixel,
	CombineAlpha: CombineAlpha,
	AlphaBlend: AlphaBlend,
	DrawHorizontalLine1px: DrawHorizontalLine1px,
	DrawVerticalLine1px: DrawVerticalLine1px,
	DrawRectangle1px: DrawRectangle1px,
	DrawImageOnImage: DrawImageOnImage,
	DrawLine1px: DrawLine1px,
	XiaolinWusLineAlgorithm: XiaolinWusLineAlgorithm,
	OneMinusFractionalPart: OneMinusFractionalPart,
	FractionalPart: FractionalPart,
	SetBrightness: SetBrightness,
	DrawQuadraticBezierCurve: DrawQuadraticBezierCurve,
	QuadraticBezierPoint: QuadraticBezierPoint,
	DrawCubicBezierCurve: DrawCubicBezierCurve,
	CubicBezierPoint: CubicBezierPoint,
	CopyImage: CopyImage,
	GetImagePixel: GetImagePixel,
	HorizontalFlip: HorizontalFlip,
	DrawFilledRectangle: DrawFilledRectangle,
	RotateAntiClockwise90Degrees: RotateAntiClockwise90Degrees,
	DrawCircle: DrawCircle,
	BresenhamsCircleDrawingAlgorithm: BresenhamsCircleDrawingAlgorithm,
	DrawCircleMidpointAlgorithm: DrawCircleMidpointAlgorithm,
	DrawCircleBasicAlgorithm: DrawCircleBasicAlgorithm,
	DrawFilledCircle: DrawFilledCircle,
	DrawFilledCircleMidpointAlgorithm: DrawFilledCircleMidpointAlgorithm,
	DrawFilledCircleBasicAlgorithm: DrawFilledCircleBasicAlgorithm,
	DrawTriangle: DrawTriangle,
	DrawFilledTriangle: DrawFilledTriangle,
	DrawLine: DrawLine,
	DrawLineBresenhamsAlgorithmThick: DrawLineBresenhamsAlgorithmThick,
	DrawLineBresenhamsAlgorithm: DrawLineBresenhamsAlgorithm,
	DrawLineBresenhamsAlgorithmThickPatterned: DrawLineBresenhamsAlgorithmThickPatterned,
	GetLinePattern5: GetLinePattern5,
	GetLinePattern4: GetLinePattern4,
	GetLinePattern3: GetLinePattern3,
	GetLinePattern2: GetLinePattern2,
	GetLinePattern1: GetLinePattern1,
	Blur: Blur,
	CreateBlurForPoint: CreateBlurForPoint,
	AssertFalse: AssertFalse,
	AssertTrue: AssertTrue,
	AssertEquals: AssertEquals,
	AssertBooleansEqual: AssertBooleansEqual,
	AssertCharactersEqual: AssertCharactersEqual,
	AssertStringEquals: AssertStringEquals,
	AssertNumberArraysEqual: AssertNumberArraysEqual,
	AssertBooleanArraysEqual: AssertBooleanArraysEqual,
	AssertStringArraysEqual: AssertStringArraysEqual,
	Negate: Negate,
	Positive: Positive,
	Factorial: Factorial,
	Round: Round,
	BankersRound: BankersRound,
	Ceil: Ceil,
	Floor: Floor,
	Truncate: Truncate,
	Absolute: Absolute,
	Logarithm: Logarithm,
	NaturalLogarithm: NaturalLogarithm,
	Sin: Sin,
	Cos: Cos,
	Tan: Tan,
	Asin: Asin,
	Acos: Acos,
	Atan: Atan,
	Atan2: Atan2,
	Squareroot: Squareroot,
	Exp: Exp,
	DivisibleBy: DivisibleBy,
	Combinations: Combinations,
	Permutations: Permutations,
	EpsilonCompare: EpsilonCompare,
	GreatestCommonDivisor: GreatestCommonDivisor,
	GCDWithSubtraction: GCDWithSubtraction,
	IsInteger: IsInteger,
	GreatestCommonDivisorWithCheck: GreatestCommonDivisorWithCheck,
	LeastCommonMultiple: LeastCommonMultiple,
	Sign: Sign,
	Max: Max,
	Min: Min,
	Power: Power,
	Gamma: Gamma,
	LogGamma: LogGamma,
	LanczosApproximation: LanczosApproximation,
	Beta: Beta,
	Sinh: Sinh,
	Cosh: Cosh,
	Tanh: Tanh,
	Cot: Cot,
	Sec: Sec,
	Csc: Csc,
	Coth: Coth,
	Sech: Sech,
	Csch: Csch,
	Error: Error,
	ErrorInverse: ErrorInverse,
	FallingFactorial: FallingFactorial,
	RisingFactorial: RisingFactorial,
	Hypergeometric: Hypergeometric,
	HypergeometricDirect: HypergeometricDirect,
	BernouilliNumber: BernouilliNumber,
	AkiyamaTanigawaAlgorithm: AkiyamaTanigawaAlgorithm,
	StringToNumberArray: StringToNumberArray,
	NumberArrayToString: NumberArrayToString,
	NumberArraysEqual: NumberArraysEqual,
	BooleanArraysEqual: BooleanArraysEqual,
	StringsEqual: StringsEqual,
	FillNumberArray: FillNumberArray,
	FillString: FillString,
	FillBooleanArray: FillBooleanArray,
	FillNumberArrayRange: FillNumberArrayRange,
	FillBooleanArrayRange: FillBooleanArrayRange,
	FillStringRange: FillStringRange,
	CopyNumberArray: CopyNumberArray,
	CopyBooleanArray: CopyBooleanArray,
	CopyString: CopyString,
	CopyNumberArrayRange: CopyNumberArrayRange,
	CopyBooleanArrayRange: CopyBooleanArrayRange,
	CopyStringRange: CopyStringRange,
	IsLastElement: IsLastElement,
	CreateNumberArray: CreateNumberArray,
	CreateBooleanArray: CreateBooleanArray,
	CreateString: CreateString,
	SwapElementsOfNumberArray: SwapElementsOfNumberArray,
	SwapElementsOfStringArray: SwapElementsOfStringArray,
	ReverseNumberArray: ReverseNumberArray,
	test: test
};